/*******************************************************************************
*  skUART2lib.c - t`qsQ֐Cu(PUrbglbtp)               *
*                 ̃CuUART(VAʐM)sׂ̊֐Wł       *
*                 UART1/UART22@\PICpUART2̂ݓ\łB       *
*                                                                              *
*    U2ErrInterrupt  - t`qsQG[̊荞ݏ                          *
*    U2TXInterrupt   - t`qsQM̊荞ݏ                            *
*    U2RXInterrupt   - t`qsQM̊荞ݏ                            *
*    InitUART2       - t`qsQʐM̏s                        *
*    UART2_Send      - Ɏw肵̃f[^𑗐M鏈                *
*    UART2_Write     - ɂPoCg̃f[^𑗐M鏈                    *
*    UART2_Available - Mf[^̌Ԃ                          *
*    UART2_Read      - Mf[^PoCgǂݍޏ                    *
*    UART2_Flush     - Mobt@NA鏈                            *
*                                                                              *
*    F                                                                    *
*         __delay_us() and __delay_ms() gpĂ̂ "skUART2lib.h"    *
*         "#define FCY 60000000UL"LqĂA120MHz(60MIPS)ȊO       *
*         CPUNbNɂl͏܂傤B                              *
*                                                                              *
*         WUART2_8N1(8bit,nonParity,1stop)A"skUART2lib.h"̋Lq A *
*         #define UART2_8O1Ƃ(8bit,OddParity,1stop)őMA            *
*         #define UART2_8E1Ƃ(8bit,EvenParity,1stop)őMo܂B     *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*   2.00    2020-05-12  ޒH[(ނ)  Create(skUARTlibVr2.00쐬)*
* ============================================================================ *
*  PIC24E(24EP256MC202) PIC24F(24FJ64GB002)                                    *
*  MPLAB X(v5.30)                                                              *
*  MPLAB(R) XC16 C Compiler Version 1.30                                       *
*******************************************************************************/
#include <xc.h>
#include "skUART2lib.h"


char UART2_Buffer[UART2_BUFFER_SIZE] ;  // Mf[^i[obt@
int  UART2_Buffer_inptr ;               // Mobt@̓ǂݍ݃|C^[
int  UART2_Buffer_outptr ;              // Mobt@̏݃|C^[


/*******************************************************************************
*  U2ErrInterrupt( void )                                                      *
*    t`qsQG[̊荞ݏ                                            *
*    I[oG[(OEER)^t[~OG[(FERR)^peBG[(PERR)    *
*    t[~OG[^peBG[ĂĂȂ̂܂܎M    *
*******************************************************************************/
void __attribute__((interrupt, no_auto_psv)) _U2ErrInterrupt(void)
{
     // I[oG[(Mobt@Tڂ̃f[^MI[ot[)
     if (URXOERR2 == 1) {
          // NAĂ邾Ȃ̂ŎMobt@̃f[^͔j܂
          URXOERR2 = 0 ;
     }

     // ݃tOZbg
     UEIF2 = 0 ;
}
/*******************************************************************************
*  U2TXInterrupt( void )                                                       *
*    t`qsQM̊荞ݏ                                              *
*******************************************************************************/
void __attribute__((interrupt, no_auto_psv)) _U2TXInterrupt(void)
{
     // ݃tOZbg
     UTXIF2 = 0 ;
}
/*******************************************************************************
*  U2RXInterrupt( void )                                                       *
*    t`qsQM̊荞ݏ                                              *
*******************************************************************************/
void __attribute__((interrupt, no_auto_psv)) _U2RXInterrupt(void)
{
     int  x ;
     char dt ;

     if (URXDA2 == 1) {
          // WX^f[^M
          dt = URXREG2 ;
          x = (UART2_Buffer_outptr + 1) % UART2_BUFFER_SIZE ;
          if (x != UART2_Buffer_inptr) {
               // obt@tłȂȂf[^ۑ
               UART2_Buffer[UART2_Buffer_outptr] = dt ;
               // obt@݃|C^[ɐi߂
               UART2_Buffer_outptr = x ;
          }
     }

     // ݃tOZbg
     URXIF2 = 0 ;
}
/*******************************************************************************
*  InitUART2(rx,tx,brg)                                                        *
*    t`qsQʐM̏s                                          *
*    rx  : M(RX)s̔ԍw肷(gp)                            *
*    tx  : M(TX)s̔ԍw肷(gp)                            *
*    brg : {[[gw肵܂(ʐMxɂȂ܂)                          *
*******************************************************************************/
void InitUART2(int rx, int tx, long brg)
{
     // ް𑗐Mڼ޽֓]ɊݔA1޲ĎMɊݔ
     USTA2  = 0b0000000000000000 ;
     // {[[g̐ݒ
     UBRGH2 = 0 ;
     UBRG2  = ((FCY/brg)/16)-1 ;         // Wx[hŃZbg
     if (UBRG2 < 103) {
          UBRGH2 = 1 ;
          UBRG2  = ((FCY/brg)/4)-1 ;     // [hŃZbg         
     }
#if defined(UART_8O1)
     // Data=8bit Parity=0dd Stop=1bit Flow=none
     PDSEL2 = 0b10 ;
     STSEL2 = 0 ;
#else
#if defined(UART_8E1)
     // Data=8bit Parity=Even Stop=1bit Flow=none
     PDSEL2 = 0b01 ;
     STSEL2 = 0 ;
#else
     // Data=8bit Parity=none Stop=1bit Flow=none
     PDSEL2 = 0b00 ;
     STSEL2 = 0 ;
#endif
#endif
     UEIE2  = 1 ;                  // UART2G[݂
     UEIP2  = 4 ;                  // UART2G[ݗD惌x(0-7)ݒ肷
     UEIF2  = 0 ;                  // UART2G[݃tONA
     UTXIE2  = 1 ;                 // UART2M݂
     UTXIP2  = 4 ;                 // UART2MݗD惌x(0-7)ݒ肷
     UTXIF2  = 0 ;                 // UART2M݃tONA
     URXIE2  = 1 ;                 // UART2M݂
     URXIP2  = 5 ;                 // UART2MݗD惌x(0-7)ݒ肷
     URXIF2  = 0 ;                 // UART2M݃tONA
     UARTEN2 = 1 ;                 // UART2Lɂ
     UTXEN2  = 1 ;                 // UART2̑MLɂ
     UART2_Buffer_inptr  = 0 ;     // Mobt@̓ǂݍ݃|C^[̏
     UART2_Buffer_outptr = 0 ;     // Mobt@̏݃|C^[̏
     // ) 1000000/9600bps=104us͍Œ҂KvL邪A400us҂ɂ
     __delay_us(400) ;
}
/*******************************************************************************
*  UART2_Send(dt,num)                                                          *
*    Ɏw肵̃f[^𑗐M鏈                                  *
*                                                                              *
*    dt  : Mf[^i[zw肵܂B                          *
*    num : Mf[^̌w肵܂B                                  *
*******************************************************************************/
void UART2_Send(const char *dt,int num)
{
     int i ;

     // w肵JԂ
     for (i=0 ; i<num ; i++) {
          while(UTXBF2==1) ;  // Mobt@FULLȂ󂭂܂ő҂
          UTXREG2 = *dt++ ;   // M
     }
}
/*******************************************************************************
*  UART2_Write(dt)                                                             *
*    ɂPoCg̃f[^𑗐M鏈                                      *
*                                                                              *
*    dt  : Mf[^w肵܂B                                        *
*******************************************************************************/
void UART2_Write(char dt)
{
     while(UTXBF2==1) ;       // Mobt@FULLȂ󂭂܂ő҂
     UTXREG2 = dt ;           // M
}
/*******************************************************************************
*  ans = UART2_Available()                                                     *
*    Mf[^̌Ԃ                                            *
*                                                                              *
*    ans : Mf[^̌Ԃ܂B                                    *
*******************************************************************************/
int UART2_Available()
{
     return (UART2_Buffer_outptr + UART2_BUFFER_SIZE - UART2_Buffer_inptr) % UART2_BUFFER_SIZE ;
}
/*******************************************************************************
*  ans = UART2_Read()                                                          *
*    Mf[^PoCgǂݍޏ                                      *
*                                                                              *
*    ans : Mf[^Ԃ܂  0xffffԂMf[^͋łB      *
*******************************************************************************/
unsigned int UART2_Read()
{
     unsigned int  ans ;

     // obt@͋ł
     if (UART2_Buffer_inptr == UART2_Buffer_outptr) return 0xffff ;
     // obt@ǂݏo
     ans = UART2_Buffer[UART2_Buffer_inptr] ;
     // obt@ǂݍ݃|C^[ɐi߂
     UART2_Buffer_inptr = (UART2_Buffer_inptr + 1) % UART2_BUFFER_SIZE ;

     return ans ;
}
/*******************************************************************************
*  UART2_Flush()                                                               *
*    Mobt@NA鏈                                              *
*******************************************************************************/
void UART2_Flush()
{
     UART2_Buffer_inptr  = 0 ;     // Mobt@̓ǂݍ݃|C^[̏
     UART2_Buffer_outptr = 0 ;     // Mobt@̏݃|C^[̏
}
