/*******************************************************************************
*  skUART2lib.h - UART2ʐMs֐̃CN[ht@C(16rbgMCUp)   *
*                 UART1/UART22@\PICpUART2̂ݓ\łB       *
*                                                                              *
* ============================================================================ *
*   VERSION DATE        BY                    CHANGE/COMMENT                   *
* ---------------------------------------------------------------------------- *
*   2.00    2020-05-12  ޒH[(ނ)  Create(skUARTlibVr2.00쐬)*
*******************************************************************************/
#ifndef _SKUART2LIB_H_
#define _SKUART2LIB_H_

// __delay_ms__delay_usƃ{[[ǧvZɕKv
#ifndef FCY
  // Unless already defined assume 120MHz(60MIPS) system frequency
  #define FCY 60000000UL           // Fosc/2(60MIPS)
  #include <libpic30.h>
#endif

#define UART2_8N1                  // Data=8bit Parity=none Stop=1bit Flow=none (W)
//#define UART2_8O1                  // Data=8bit Parity=0dd Stop=1bit Flow=none (peBL))
//#define UART2_8E1                  // Data=8bit Parity=Even Stop=1bit Flow=none (peBL))

#define UART2_BUFFER_SIZE   64     // t`qsQ̎Mobt@TCY

// t`qsQW[̃WX^[`
#define UMODE2   U2MODE
#define USTA2    U2STA
#define UARTEN2  U2MODEbits.UARTEN
#define UTXEN2   U2STAbits.UTXEN
#define UBRGH2   U2MODEbits.BRGH
#define PDSEL2   U2MODEbits.PDSEL
#define STSEL2   U2MODEbits.STSEL
#define UBRG2    U2BRG
#define UTXREG2  U2TXREG
#define UTXIF2   _U2TXIF
#define UTXIE2   _U2TXIE
#define UTXIP2   _U2TXIP
#define UTXBF2   U2STAbits.UTXBF
#define URXDA2   U2STAbits.URXDA
#define URXOERR2 U2STAbits.OERR
#define URXREG2  U2RXREG
#define URXIF2   _U2RXIF
#define URXIE2   _U2RXIE
#define URXIP2   _U2RXIP
#if defined(__PIC24E__)
#define UEIF2    _U2EIF
#define UEIE2    _U2EIE
#define UEIP2    _U2EIP
#else
#define UEIF2    _U2ERIF
#define UEIE2    _U2ERIE
#define UEIP2    _U2ERIP
#endif

// ֐̃vg^Cv錾
void InitUART2(int rx, int tx, long brg) ;
void UART2_Send(const char *dt,int num) ;
void UART2_Write(char dt) ;
int  UART2_Available() ;
unsigned int UART2_Read() ;
void UART2_Flush() ;

#endif
