/*******************************************************************************
*  skUARTlib - t`qs֐Cu(PUrbglbtp)                    *
*          ̃CuUART(VAʐM)sׂ̊֐Wł              *
*                                                                              *
*    UErrInterrupt  - t`qsG[̊荞ݏ                             *
*    UTXInterrupt   - t`qsM̊荞ݏ                               *
*    URXInterrupt   - t`qsM̊荞ݏ                               *
*    InitUART       - t`qsʐM̏s                           *
*    UART_Send      - Ɏw肵̃f[^𑗐M鏈                 *
*    UART_Write     - ɂPoCg̃f[^𑗐M鏈                     *
*    UART_Available - Mf[^̌Ԃ                           *
*    UART_Read      - Mf[^PoCgǂݍޏ                     *
*    UART_Flush     - Mobt@NA鏈                             *
*                                                                              *
*    F                                                                    *
*         __delay_us() and __delay_ms() gpĂ̂ "skUARTlib.h"     *
*         "#define FCY 60000000UL"LqĂA120MHz(60MIPS)ȊO       *
*         CPUNbNɂl͏܂傤B                              *
*                                                                              *
*         UART2𗘗pꍇ́AskUARTlib.h"#define UART2_USE"錾    *
*                                                                              *
*         WUART_8N1(8bit,nonParity,1stop)A"skUARTlib.h"̋Lq A   *
*         #define UART_8O1Ƃ(8bit,OddParity,1stop)őMA             *
*         #define UART_8E1Ƃ(8bit,EvenParity,1stop)őMo܂B      *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2015-09-01  ޒH[(ނ)  Create                            *
*  2.00    2019-01-07  ޒH[(ނ)  PIC24F,peB,[hɑΉ  *
* ============================================================================ *
*  PIC24E(24EP256MC202) PIC24F(24FJ64GB002)                                    *
*  MPLAB X(v4.10)                                                              *
*  MPLAB(R) XC16 C Compiler Version 1.30                                       *
*******************************************************************************/
#include <xc.h>
#include "skUARTlib.h"


char UART_Buffer[UART_BUFFER_SIZE] ;    // Mf[^i[obt@
int  UART_Buffer_inptr ;                // Mobt@̓ǂݍ݃|C^[
int  UART_Buffer_outptr ;               // Mobt@̏݃|C^[


/*******************************************************************************
*  UErrInterrupt( void )                                                       *
*    t`qsG[̊荞ݏ                                              *
*    I[oG[(OEER)^t[~OG[(FERR)^peBG[(PERR)    *
*    t[~OG[^peBG[ĂĂȂ̂܂܎M    *
*******************************************************************************/
#ifdef  UART2_USE
void __attribute__((interrupt, no_auto_psv)) _U2ErrInterrupt(void)
#else
void __attribute__((interrupt, no_auto_psv)) _U1ErrInterrupt(void)
#endif
{
     // I[oG[(Mobt@Tڂ̃f[^MI[ot[)
     if (URXOERR == 1) {
          // NAĂ邾Ȃ̂ŎMobt@̃f[^͔j܂
          URXOERR = 0 ;
     }

     // ݃tOZbg
     UEIF = 0 ;
}
/*******************************************************************************
*  UTXInterrupt( void )                                                        *
*    t`qsM̊荞ݏ                                                *
*******************************************************************************/
#ifdef  UART2_USE
void __attribute__((interrupt, no_auto_psv)) _U2TXInterrupt(void)
#else
void __attribute__((interrupt, no_auto_psv)) _U1TXInterrupt(void)
#endif
{
     // ݃tOZbg
     UTXIF = 0 ;
}
/*******************************************************************************
*  URXInterrupt( void )                                                        *
*    t`qsM̊荞ݏ                                                *
*******************************************************************************/
#ifdef  UART2_USE
void __attribute__((interrupt, no_auto_psv)) _U2RXInterrupt(void)
#else
void __attribute__((interrupt, no_auto_psv)) _U1RXInterrupt(void)
#endif
{
     int  x ;
     char dt ;

     if (URXDA == 1) {
          // WX^f[^M
          dt = URXREG ;
          x = (UART_Buffer_outptr + 1) % UART_BUFFER_SIZE ;
          if (x != UART_Buffer_inptr) {
               // obt@tłȂȂf[^ۑ
               UART_Buffer[UART_Buffer_outptr] = dt ;
               // obt@݃|C^[ɐi߂
               UART_Buffer_outptr = x ;
          }
     }

     // ݃tOZbg
     URXIF = 0 ;
}
/*******************************************************************************
*  InitUART(rx,tx,brg)                                                         *
*    t`qsʐM̏s                                            *
*    rx  : M(RX)s̔ԍw肷(gp)                            *
*    tx  : M(TX)s̔ԍw肷(gp)                            *
*    brg : {[[gw肵܂(ʐMxɂȂ܂)                          *
*******************************************************************************/
void InitUART(int rx, int tx, long brg)
{
     // ް𑗐Mڼ޽֓]ɊݔA1޲ĎMɊݔ
     USTA  = 0b0000000000000000 ;
     // {[[g̐ݒ
     UBRGH = 0 ;
     UBRG  = ((FCY/brg)/16)-1 ;         // Wx[hŃZbg
     if (UBRG < 103) {
          UBRGH = 1 ;
          UBRG  = ((FCY/brg)/4)-1 ;     // [hŃZbg         
     }
#if defined(UART_8O1)
     // Data=8bit Parity=0dd Stop=1bit Flow=none
     PDSEL = 0b10 ;
     STSEL = 0 ;
#else
#if defined(UART_8E1)
     // Data=8bit Parity=Even Stop=1bit Flow=none
     PDSEL = 0b01 ;
     STSEL = 0 ;
#else
     // Data=8bit Parity=none Stop=1bit Flow=none
     PDSEL = 0b00 ;
     STSEL = 0 ;
#endif
#endif
     UEIE  = 1 ;                   // UARTG[݂
     UEIP  = 4 ;                   // UARTG[ݗD惌x(0-7)ݒ肷
     UEIF  = 0 ;                   // UARTG[݃tONA
     UTXIE  = 1 ;                  // UARTM݂
     UTXIP  = 4 ;                  // UARTMݗD惌x(0-7)ݒ肷
     UTXIF  = 0 ;                  // UARTM݃tONA
     URXIE  = 1 ;                  // UARTM݂
     URXIP  = 5 ;                  // UARTMݗD惌x(0-7)ݒ肷
     URXIF  = 0 ;                  // UARTM݃tONA
     UARTEN = 1 ;                  // UARTLɂ
     UTXEN  = 1 ;                  // UART̑MLɂ
     UART_Buffer_inptr  = 0 ;      // Mobt@̓ǂݍ݃|C^[̏
     UART_Buffer_outptr = 0 ;      // Mobt@̏݃|C^[̏
     // ) 1000000/9600bps=104us͍Œ҂KvL邪A400us҂ɂ
     __delay_us(400) ;
}
/*******************************************************************************
*  UART_Send(dt,num)                                                           *
*    Ɏw肵̃f[^𑗐M鏈                                  *
*                                                                              *
*    dt  : Mf[^i[zw肵܂B                          *
*    num : Mf[^̌w肵܂B                                  *
*******************************************************************************/
void UART_Send(const char *dt,int num)
{
     int i ;

     // w肵JԂ
     for (i=0 ; i<num ; i++) {
          while(UTXBF==1) ;   // Mobt@FULLȂ󂭂܂ő҂
          UTXREG = *dt++ ;    // M
     }
}
/*******************************************************************************
*  UART_Write(dt)                                                              *
*    ɂPoCg̃f[^𑗐M鏈                                      *
*                                                                              *
*    dt  : Mf[^w肵܂B                                        *
*******************************************************************************/
void UART_Write(char dt)
{
     while(UTXBF==1) ;        // Mobt@FULLȂ󂭂܂ő҂
     UTXREG = dt ;            // M
}
/*******************************************************************************
*  ans = UART_Available()                                                      *
*    Mf[^̌Ԃ                                            *
*                                                                              *
*    ans : Mf[^̌Ԃ܂B                                    *
*******************************************************************************/
int UART_Available()
{
     return (UART_Buffer_outptr + UART_BUFFER_SIZE - UART_Buffer_inptr) % UART_BUFFER_SIZE ;
}
/*******************************************************************************
*  ans = UART_Read()                                                           *
*    Mf[^PoCgǂݍޏ                                      *
*                                                                              *
*    ans : Mf[^Ԃ܂  0xffffԂMf[^͋łB      *
*******************************************************************************/
unsigned int UART_Read()
{
     unsigned int  ans ;

     // obt@͋ł
     if (UART_Buffer_inptr == UART_Buffer_outptr) return 0xffff ;
     // obt@ǂݏo
     ans = UART_Buffer[UART_Buffer_inptr] ;
     // obt@ǂݍ݃|C^[ɐi߂
     UART_Buffer_inptr = (UART_Buffer_inptr + 1) % UART_BUFFER_SIZE ;

     return ans ;
}
/*******************************************************************************
*  UART_Flush()                                                                *
*    Mobt@NA鏈                                              *
*******************************************************************************/
void UART_Flush()
{
     UART_Buffer_inptr  = 0 ;      // Mobt@̓ǂݍ݃|C^[̏
     UART_Buffer_outptr = 0 ;      // Mobt@̏݃|C^[̏
}
